#include	<stdio.h>
#include	<stdlib.h>

#include	<X11/X.h>
#include	<X11/Xlib.h>
#include	<X11/Xutil.h>
#include	<X11/Xproto.h>

#include	"wm.h"

int ignore_badwindow;

void
Panic(char *s)
{
	fprintf(stderr, "lwm: %s\n", s);
	exit(EXIT_FAILURE);
}

int
ErrorHandler(Display *d, XErrorEvent *e)
{
	char	msg[80];
	char	req[80];
	char	number[80];

	if (mode == wm_initialising &&
		 e->request_code == X_ChangeWindowAttributes &&
		 e->error_code == BadAccess)
			Panic("another window manager is already running.");

	if (ignore_badwindow &&
	    (e->error_code == BadWindow || e->error_code == BadColor))
			return 0;

	XGetErrorText(d, e->error_code, msg, sizeof(msg));
	sprintf(number, "%d", e->request_code);
	XGetErrorDatabaseText(d, "XRequest", number, "<unknown>", req, sizeof(req));

	fprintf(stderr, "lwm: %s (%#x) %s\n", req, (unsigned int) e->resourceid, msg);

	if (mode == wm_initialising)
		Panic("can't initialise.");

	return 0;
}
